#include <bits/stdc++.h>
using namespace std;
long long d[300000];
long long p[300000];
long long k[300000];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; i++)
        cin >> d[i] >> p[i];
    for (int i = 0; i < q; i++)
        cin >> k[i];
    vector<pair<long long, long long> > a;
    a.push_back({d[0], d[0] + p[0]});
    int poz = 0;
    for (int i = 1; i < n; i++) {
        if (d[i] <= a[poz].second)
            a[poz].second += p[i];
        else {
            a.push_back({d[i], d[i] + p[i]});
            poz++;
        }
    }
    int m = a.size();
    long long s = 0;
    poz = 0;
    long long upit;
    for (int i = 0; i < q; i++) {
        upit = k[i];
        while (poz < m && upit >= a[poz].second) {
            s += a[poz].second - a[poz].first;
            poz++;
        }
        if (poz == m || upit < a[poz].first)
            cout << s << '\n';
        else
            cout << s + (upit - a[poz].first + 1ll) << '\n';
    }
    return 0;
}